/* --- Copyright University of Birmingham 1996. All rights reserved. ------
 > File:            $poplocal/local/auto/get_answer.p
 > Purpose:         Get a constrained answer to a question
 > Author:          Aaron Sloman, Dec  3 1996
 > Documentation:	HELP GET_ANSWER
 > Related Files:
 */
/*

Tests:

get_answer('How old are you?', isinteger) =>

get_answer('What colour is it?', isword) =>

get_answer('How many legs?', [OR 0 2 4 6 8]) =>

lvars x,y;
get_answer('What is your name?', ![?x ?y]),x,y =>

get_answer(
		'Which limb?',
        [LOR [left leg][right leg][left arm][right arm]])=>


*/

compile_mode :pop11 +strict;

section;

define global vars get_answer(question, constraint) -> answer;

	lvars lists = false, items = false, item;

	dlocal pop_pr_quotes = false;

	repeat
		getline(question) -> answer;

		if islist(constraint) and answer matches constraint then
			return()
		elseif isprocedure(constraint) and constraint(front(answer))
		or (constraint matches ! [OR ?? items]
				and answer matches ! [? item] and member(item, items))
		then
			front(answer) -> answer;
			return()
		elseif (constraint matches ! [LOR ?? lists] and member(answer,lists))
		then
			return()
		else
			;;; Answer not in correct format
			if isprocedure(constraint) then
				['Your answer should satisfy:' ^constraint]
			elseif lists then
				['Your answer should match one of:\n\t' ^^lists]
			elseif items then
				['Your answer should be one of:' ^^items]
			else
				['Your answer should match:' ^constraint]
			endif=>
		endif
	endrepeat
enddefine;


endsection;
