/* --- The University of Birmingham 1995.  --------------------------------
 > File:            $poplocal/local/auto/ved_getvars.p
 > Purpose:			Insert local variable declaration for input and output locals
 > Author:          Aaron Sloman, Sep 10 1994 (see revisions)
 > Documentation:	HELP * VED_GETVARS
 > Related Files:
 */

section;

define lconstant is_syntax_word(word);
	lvars word, prop;
	identprops(word) -> prop;
	isword(prop)
	and
		(prop == "syntax" or isstartstring('syntax', prop))
enddefine;

define ved_getvars();
	lvars repeater, item, variables, col, inmethod = false;
	vedpositionpush();
	vedcharright();	;;; in case at beginning of procedure
	vedbacklocate('define ');
	vedcolumn + vedindentstep -> col;
	vedwordright();
	incharitem(vedrepeater) -> repeater;
	;;; go past define_form indicators, words like
	;;; global, vars, constant, etc.
	repeat
		repeater() -> item;
		if item = ":" then
			repeater() -> item;
			if item = "method" then
				true -> inmethod
			endif
		else
			quitunless
				(isinteger(item)
				or
				is_syntax_word(item))
		endif
	endrepeat;
	;;; should now be at procedure name
	repeater() ->;
	[% repeat
		repeater() -> item;
		if item == ":" and inmethod then
			;;; ignore this and next item
			repeater() -> item;
			repeater() -> item;
		endif;
		quitif(item == ";");
		unless is_syntax_word(item) then item endunless;
	   endrepeat %] -> variables;

	if variables == [] then vederror('NO INPUT OR OUTPUT LOCALS') endif;

	if vedcolumn == 1 then vedlineabove() else vedlinebelow() endif;	

	;;; Insert tabs
	until vedcolumn >= col do vedinsertstring('\t') enduntil;

	vedinsertstring('lvars ');
	lvars vars_done = [];
	for item in variables do
		unless member(item, vars_done) then
			vedinsertstring(item sys_>< ', ');
			item :: vars_done -> vars_done
		endunless;
	endfor;
	vedchardelete();vedchardelete();
	vedinsertstring(';');
	vedpositionpop();

enddefine;

endsection;

/* --- Revision History ---------------------------------------------------
--- Aaron Sloman, Oct 14 1995
	Updated to indent lvars more than 'define '
 */
