/* --- Copyright University of Birmingham 1997. All rights reserved. ------
 > File:            $poplocal/local/auto/vedsunxtermkeys.p
 > Author:          Aaron Sloman, Oct 13 1995 (see revisions)
 */

/* --- Copyright University of Sussex 1992. All rights reserved. ----------
 > 	Based on           C.all/lib/ved/term/vedsunxtermkeys.p
 > Purpose:         VED keyboard setup for xterm on a sun
 > Author:          Roger Evans, May  7 1989 (see revisions)
 > Documentation:	HELP * VEDXTERM
 > Related Files:   LIB * VEDXTERMKEYS
 */

section;

uses vedset;

define global vedsunxtermkeys();

#_IF DEF vedxsunfunctionkeys                        ;;; xterm -sf
	vedset keys
		"screenbell"    	=   esc [ 1 9 2 z       ;;; L1 (F11)
		"lineabove"         =   esc [ 1 9 3 z       ;;; L2 (F12)
		"pushkey"           =   esc [ 1 9 4 z       ;;; F3
		"linebelow"         =   esc [ 1 9 5 z       ;;; L4
		"exchangeposition"  =   esc [ 1 9 6 z       ;;; L5
		"loadline"         	= 	esc [ 1 9 7 z       ;;; L6
		"popkey"            =   esc [ 1 9 8 z       ;;; L7
		"redokey"           =   esc [ 1 9 9 z       ;;; L8
		"statusswitch"      =   esc [ 2 0 0 z       ;;; L9
		"enterkey"          =   esc [ 2 0 1 z       ;;; L10

		"screenbell"        =   esc esc [ 1 9 2 z   ;;; ESC L1 (F11)
		"ENTER crm"         =   esc esc [ 1 9 3 z   ;;; ESC L2 (F12)
		"ENTER break"       =   esc esc [ 1 9 4 z   ;;; ESC L3
		"xrefresh"          =   esc esc [ 1 9 5 z   ;;; ESC L4
		"ENTER jp"          =   esc esc [ 1 9 6 z   ;;; ESC L5
		"setstatic"         =   esc esc [ 1 9 7 z   ;;; ESC L6
		"ENTER pop"         =   esc esc [ 1 9 8 z   ;;; ESC L7

		"marklo"            =   esc [ 2 2 4 z       ;;; F1
		"markhi"            =   esc [ 2 2 5 z       ;;; F2
		"clearhead"         =   esc [ 2 2 6 z       ;;; F3
		"linedelete"        =   esc [ 2 2 7 z       ;;; F4
		"cleartail"         =   esc [ 2 2 8 z       ;;; F5
		"wordleftdelete"    =   esc [ 2 2 9 z       ;;; F6
		"wordrightdelete"   =   esc [ 2 3 0 z       ;;; F7
		"ENTER m"           =   esc [ 2 3 1 z       ;;; F8
		"ENTER t"           =   esc [ 2 3 2 z       ;;; F9
		"xrefresh"        	=   esc [ 2 3 3 z       ;;; F10 (type 4 kbd only)

		"ENTER mbf"         =   esc esc [ 2 2 4 z   ;;; ESC F1
		"ENTER mef"         =   esc esc [ 2 2 5 z   ;;; ESC F2
		"ENTER yankw"       =   esc esc [ 2 2 6 z   ;;; ESC F3
		"ENTER yankl"       =   esc esc [ 2 2 7 z   ;;; ESC F4
		"ENTER yankw"       =   esc esc [ 2 2 8 z   ;;; ESC F5
		"ENTER yankw"       =   esc esc [ 2 2 9 z   ;;; ESC F6
		"ENTER yankw"       =   esc esc [ 2 3 0 z   ;;; ESC F7
		"ENTER mi"          =   esc esc [ 2 3 1 z   ;;; ESC F8
		"ENTER ti"          =   esc esc [ 2 3 2 z   ;;; ESC F9
		"ENTER mo"          =   esc esc [ 2 3 3 z   ;;; ESC F10 (type 4 kbd only)
	endvedset
#_ELSE
	vedset keys
		"screenbell"        =   esc [ 2 3 ~         ;;; L1 (F11)
		"lineabove"         =   esc [ 2 4 ~         ;;; L2 (F12)
		"pushkey"           =   esc [ 2 5 ~         ;;; L3
		"linebelow"         =   esc [ 2 6 ~         ;;; L4
		"exchangeposition"  =   esc [ 2 8 ~         ;;; L5
		"loadline"          =   esc [ 2 9 ~         ;;; L6
		"popkey"            =   esc [ 3 1 ~         ;;; L7
		"redokey"           =   esc [ 3 2 ~         ;;; L8
		"statusswitch"      =   esc [ 3 3 ~         ;;; L9
		"enterkey"          =   esc [ 3 4 ~         ;;; L10

		"screenbell"        =   esc esc [ 2 3 ~     ;;; ESC L1 (F11)
		"ENTER crm"         =   esc esc [ 2 4 ~     ;;; ESC L2 (F12)
		"ENTER break"       =   esc esc [ 2 5 ~     ;;; ESC L3
		"xrefresh"          =   esc esc [ 2 6 ~     ;;; ESC L4
		"ENTER jp"          =   esc esc [ 2 8 ~     ;;; ESC L5
		"setstatic"         =   esc esc [ 2 9 ~     ;;; ESC L6
		"ENTER pop"         =   esc esc [ 3 1 ~     ;;; ESC L7

		"marklo"            =   esc [ 1 1 ~         ;;; F1
		"markhi"            =   esc [ 1 2 ~         ;;; F2
		"clearhead"         =   esc [ 1 3 ~         ;;; F3
		"linedelete"        =   esc [ 1 4 ~         ;;; F4
		"cleartail"         =   esc [ 1 5 ~         ;;; F5
		"wordleftdelete"    =   esc [ 1 7 ~         ;;; F6
		"wordrightdelete"   =   esc [ 1 8 ~         ;;; F7
		"ENTER m"           =   esc [ 1 9 ~         ;;; F8
		"ENTER t"           =   esc [ 2 0 ~         ;;; F9
		"xrefresh"        	=   esc [ 2 1 ~         ;;; F10 (type 4 kbd only)

		"ENTER mbf"         =   esc esc [ 1 1 ~     ;;; ESC F1
		"ENTER mef"         =   esc esc [ 1 2 ~     ;;; ESC F2
		"ENTER yankw"       =   esc esc [ 1 3 ~     ;;; ESC F3
		"ENTER yankl"       =   esc esc [ 1 4 ~     ;;; ESC F4
		"ENTER yankw"       =   esc esc [ 1 5 ~     ;;; ESC F5
		"ENTER yankw"       =   esc esc [ 1 7 ~     ;;; ESC F6
		"ENTER yankw"       =   esc esc [ 1 8 ~     ;;; ESC F7
		"ENTER mi"          =   esc esc [ 1 9 ~     ;;; ESC F8
		"ENTER ti"          =   esc esc [ 2 0 ~     ;;; ESC F9
		"ENTER mo"       	=   esc esc [ 2 1 ~     ;;; ESC F10 (type 4 kbd only)
	endvedset
#_ENDIF
	vedset keys
		"dotdelete"         =   ^H                  ;;; Back Space

		"textleft"          =   esc [ 1 1 1 ~       ;;; R1
		"screenup"          =   esc [ 1 1 2 ~       ;;; R2
		"textright"         =   esc [ 1 1 3 ~       ;;; R3
		"screenleft"        =   esc [ 1 1 4 ~       ;;; R4
		"screendown"        =   esc [ 1 1 5 ~       ;;; R5
		"screenright"       =   esc [ 1 1 7 ~       ;;; R6
		"charupleft"        =   esc [ 1 1 8 ~       ;;; R7
		"charup"            =   esc [ 1 1 9 ~       ;;; R8
		"charup"            =   esc [ A             ;;; R8
		"charupright"       =   esc [ 1 2 0 ~       ;;; R9
		"charleft"          =   esc [ 1 2 1 ~       ;;; R10
		"charleft"          =   esc [ D             ;;; R10
		"ENTER timed_esc"   =   esc [ 1 2 3 ~       ;;; R11
		"charright"         =   esc [ 1 2 4 ~       ;;; R12
		"charright"         =   esc [ C             ;;; R12
		"chardownleft"      =   esc [ 1 2 5 ~       ;;; R13
		"chardown"          =   esc [ 1 2 6 ~       ;;; R14
		"chardown"          =   esc [ B             ;;; R14
		"chardownright"     =   esc [ 1 2 8 ~       ;;; R15

		"topwindow"         =   esc esc [ 1 1 1 ~   ;;; ESC R1
		"topfile"           =   esc esc [ 1 1 2 ~   ;;; ESC R2
		"markfind"          =   esc esc [ 1 1 3 ~   ;;; ESC R3
		"midwindow"         =   esc esc [ 1 1 4 ~   ;;; ESC R4
		"endfile"           =   esc esc [ 1 1 5 ~   ;;; ESC R5
		"endrange"          =   esc esc [ 1 1 7 ~   ;;; ESC R6
		"charupleftlots"    =   esc esc [ 1 1 8 ~   ;;; ESC R7
		"charuplots"        =   esc esc [ 1 1 9 ~   ;;; ESC R8
		"charuplots"        =   esc esc [ A         ;;; ESC R8
		"charuprightlots"   =   esc esc [ 1 2 0 ~   ;;; ESC R9
		"charleftlots"      =   esc esc [ 1 2 1 ~   ;;; ESC R10
		"charleftlots"      =   esc esc [ D         ;;; ESC R10
		"midwindow"         =   esc esc [ 1 2 3 ~   ;;; ESC R11
		"charrightlots"     =   esc esc [ 1 2 4 ~   ;;; ESC R12
		"charrightlots"     =   esc esc [ C         ;;; ESC R12
		"chardownleftlots"  =   esc esc [ 1 2 5 ~   ;;; ESC R13
		"chardownlots"      =   esc esc [ 1 2 6 ~   ;;; ESC R14
		"chardownlots"      =   esc esc [ B         ;;; ESC R14
		"chardownrightlots" =   esc esc [ 1 2 8 ~   ;;; ESC R15

	/*  Extra bindings for type 4 keyboard */

		"helpkey"           =   esc K               ;;; Help
		"ENTER hkey"        =   esc esc K           ;;; ESC Help
		"wordleft"          =   esc O p             ;;; KP 0
		"wordright"         =   esc O n             ;;; KP .
		"enterkey"          =   esc O M             ;;; Enter
		"statusswitch"      =   esc O k             ;;; KP +
		"redokey"           =   esc O m             ;;; KP -
		;;; on Sun type5
		"redokey"           =   esc [ 1 1 4 ~       ;;; KP -
		"screenbell"        =   esc [ 1 1 0 ~       ;;; NumLock

	endvedset;
;;; Stuff for Xved
	vedsetkey('\^[[FFC9', "vedlineabove");			;;; L2
	vedsetkey('\^[[FFCA', "vedpushkey");			;;; L3
	vedsetkey('\^[[FFCB', "vedlinebelow");			;;; L4
	vedsetkey('\^[[FFCC', "vedexchangeposition");	;;; L5
	vedsetkey('\^[[FFCD', "vedloadline");			;;; L6
	vedsetkey('\^[[FFCE', "vedpopkey");				;;; L7
	vedsetkey('\^[[FFCF', "vedredokey");			;;; L8
	vedsetkey('\^[[FFD0', "vedstatusswitch");		;;; L9
	vedsetkey('\^[[FFD1', "vedenterkey");			;;; L10

	vedsetkey('\^[\^[[FFC9', "ved_crm");			;;; ESC L2
	vedsetkey('\^[\^[[FFCA', "ved_break");			;;; ESC L3
	vedsetkey('\^[\^[[FFCB', "vedrefresh");			;;; ESC L4
	vedsetkey('\^[\^[[FFCC', "ved_jp");				;;; ESC L5
	vedsetkey('\^[\^[[FFCD', "vedsetstatic");		;;; ESC L6
	vedsetkey('\^[\^[[FFCE', "ved_pop");			;;; ESC L7

;;; Stuff for Motif XVed
	vedsetkey('\^[[FF8D', "vedenter");			;;; ENTER
	vedsetkey('\^[[FFBE', "vedmarklo");			;;; F1
	vedsetkey('\^[\^[[FFBE', "ved_mbf");		;;; ESC F1

;;; Middle pad (On Sun type 5 keyboard)
	vedsetkey('\^[[FF63', "vedlineabove");		;;; Insert
	vedsetkey('\^[[FF50', "vedtopfile");		;;; Home
;;;	vedsetkey('\^[\^[[FF50', "ved????");		;;; ESC Home
	vedsetkey('\^[[FF57', "vedendfile");		;;; End
;;;	vedsetkey('\^[\^[[FF57', "ved????");		;;; ESC End
	vedsetkey('\^[[FF55', "vedprevscreen");		;;; Page up
;;;	vedsetkey('\^[\^[[FF55', "ved????");		;;; ESC Page up
	vedsetkey('\^[[FF56', "vednextscreen");		;;; Page dn
;;;	vedsetkey('\^[\^[[FF56', "ved????");		;;; ESC Page dn

;;; Arrow pad
;;;	vedsetkey('\^[[FF52', "vedscreenup");		;;; Up
	vedsetkey('\^[[FF52', "vedcharup");		;;; Up
	vedsetkey('\^[\^[[FF52', "vedtopfile");		;;; ESC Up
;;;	vedsetkey('\^[[FF51', "vedscreenleft");		;;; Left
	vedsetkey('\^[[FF51', "vedcharleft");		;;; Left
	vedsetkey('\^[\^[[FF51', "vedtextleft");	;;; ESC Left
;;;	vedsetkey('\^[[FF54', "vedscreendown");		;;; Down
	vedsetkey('\^[[FF54', "vedchardown");		;;; Down
	vedsetkey('\^[\^[[FF54', "vedendfile");		;;; ESC Down
;;;	vedsetkey('\^[[FF53', "vedtextright");		;;; Right
	vedsetkey('\^[[FF53', "vedcharright");		;;; Right
;;;	vedsetkey('\^[\^[[FF53', "vedscreenright");	;;; ESC Right
	vedsetkey('\^[\^[[FF53', "vedtextright");	;;; ESC Right

	vedset keys
	/* Extra binding for type 5 keyboard, outside XVed
		(these are copied from LIB VEDNCDXTERMKEYS)
	*/

		"lineabove"         =   esc [ 2 ~           ;;; INSERT
		"prevscreen"        =   esc [ 5 ~           ;;; PAGE UP
		"nextscreen"        =   esc [ 6 ~           ;;; PAGE DOWN
		"topfile"           =   esc <               ;;; HOME
		"endfile"           =   esc >               ;;; END

		"linebelow"         =   esc esc [ 2 ~       ;;; ESC INSERT
		"ENTER xup"         =   esc esc [ 5 ~       ;;; ESC PAGE UP
		"ENTER xdn"         =   esc esc [ 6 ~       ;;; ESC PAGE DOWN
		"markfind"          =   esc esc <           ;;; ESC HOME
		"endrange"          =   esc esc >           ;;; ESC END
	endvedset;
    vedsetkey('\^L', "vedxrefresh");
	'sunxterm' -> vedkeymapname
enddefine;


endsection;


/* --- Revision History ---------------------------------------------------
--- Aaron Sloman, Jun 19 1997
	Set CTRL-L to vedxrefresh
--- Aaron Sloman 13 Oct 1995
		Put all procedure names in word quotes. Added stuff for XVed
		under motif.
--- Aaron Sloman 15 Feb 1995
	Changed R13 and R15 do downleft and downright
--- Aaron Sloman 8 Feb 1995
	Added stuff for XVED left hand keypad
--- Aaron Sloman 16 Oct 1994
	Modified to cope with cases where R8, R10, R12, R14 keys are transmitting
		sun sequences rather than arrow key sequences.
--- John Williams, Apr 20 1993
		Added new key mappings for Sun type 5 keyboard
--- John Williams, Jul  6 1993
		Changed vedkeymapname to 'sunxterm'
--- John Williams, Aug 17 1992
		Added ~ to the end of the character sequence for the NumLock key
--- John Williams, Oct 16 1990
		Merged with LIB * VEDSUNSFXTERMKEYS, added type 4 keyboard bindings,
		sets -vedkeymapname-.
--- Rob Duncan, Oct  9 1989
		Sectionised
--- Andreas Schoter, Aug 1 1989
		Modified to use vedset syntax and screen stuff seperated out
 */
